Attribute VB_Name = "MathGaussJordan"
Option Explicit
Option Base 1

Public Sub GaussJ(A() As Double, B() As Double)

    Dim IndxC() As Long, IndxR() As Long, iPiv() As Long
    Dim N As Long, M As Long
    Dim I As Long, Icol As Long, Irow As Long
    Dim J As Long, K As Long, L As Long, LL As Long
    Dim Big As Double, Dum As Double, PivInv As Double, Temp As Double
    
    N = UBound(A, 1)
    M = UBound(B, 2)
    ReDim IndxC(1 To N), IndxR(1 To N), iPiv(1 To N)
    
    For I = 1 To N
    
        Big = 0#
        
        For J = 1 To N
            If iPiv(J) <> 1 Then
                For K = 1 To N
                    If iPiv(K) = 0 And Abs(A(J, K)) >= Big Then
                        Big = Abs(A(J, K))
                        Irow = J
                        Icol = K
                    ElseIf iPiv(K) > 1 Then
                        Err.Raise ERR_NUM_GaussJ_1, , ERR_DSC_GaussJ_1
                    End If
                Next K
            End If
        Next J
        
        iPiv(Icol) = iPiv(Icol) + 1
        
        If Irow <> Icol Then
            For L = 1 To N
                Temp = A(Irow, L)
                A(Irow, L) = A(Icol, L)
                A(Icol, L) = Temp
            Next L
            For L = 1 To M
                Temp = B(Irow, L)
                B(Irow, L) = B(Icol, L)
                B(Icol, L) = Temp
            Next L
        End If
        
        IndxR(I) = Irow: IndxC(I) = Icol
        
        If A(Icol, Icol) = 0# Then _
            Err.Raise ERR_NUM_GaussJ_2, , ERR_DSC_GaussJ_2
        
        PivInv = 1# / A(Icol, Icol): A(Icol, Icol) = 1#
        
        For L = 1 To N
            A(Icol, L) = A(Icol, L) * PivInv
        Next L
        For L = 1 To M
            B(Icol, L) = B(Icol, L) * PivInv
        Next L
        
        For LL = 1 To N
            If LL <> Icol Then
                Dum = A(LL, Icol)
                A(LL, Icol) = 0#
                For L = 1 To N
                    A(LL, L) = A(LL, L) - A(Icol, L) * Dum
                Next L
                For L = 1 To M
                    B(LL, L) = B(LL, L) - B(Icol, L) * Dum
                Next L
            End If
        Next LL
        
    Next I
      
    For L = N To 1 Step -1
        If IndxR(L) <> IndxC(L) Then
            For K = 1 To N
                Temp = A(K, IndxR(L))
                A(K, IndxR(L)) = A(K, IndxC(L))
                A(K, IndxC(L)) = Temp
            Next K
        End If
    Next L

End Sub
